Redmine - Defect #37237

Common Markdown Formatter does not render all properties on HTML elements
2022-06-1013:10-C S

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Text formatting Estimated time: 0.00 hour
Target version: 5.0.3

Resolution: Fixed Affected version: 5.0.0
Description

Input:

<table align="center" border="0" cellpadding="1" cellspacing="1" style="width:100%; text-align:cen
ter; border-collapse:separate; border-spacing: 10px; display:table">
<tr>
<td class="InfoButton">Some Text</td>
</tr>
</table>

Output:

<table align="center" border="0" cellpadding="1" cellspacing="1">
<tr>
<td>Some Text</td>
</tr>
</table>

Related issues:

Related to Redmine - Feature #2416: {background:color} doesn't work in text f... Closed 2008-12-30
Related to Redmine - Feature #22425: Allow "style" tag in Redcarpet Markdown ... Closed
Related to Redmine - Defect #38073: CommonMark Markdown formatter does not su... Closed
Is duplicate of Redmine - Feature #35747: Allow style attribute for HTML elem... Closed

Associated revisions

Revision 21850 - 2022-09-27 00:35 - Marius BALTEANU
Allow select custom CSS properties (#37237).

Patch by Jens Kramer.

Revision 21851 - 2022-09-27 00:36 - Marius BALTEANU

Adds info about custom CSS to commonmark markdown help (#37237).

Patch by Jens Kramer.

Revision 21859 - 2022-09-27 19:11 - Marius BALTEANU
Merged r21850 and r21851 from trunk to 5.0-stable (#37237).

History

#1 - 2022-06-13 13:16 - Anonymous
- File blog-categories-2022-05-13.csv added

#2 - 2022-06-16 16:58 - Holger Just
- File deleted (blog-categories-2022-05-13.csv)

#3 - 2022-07-06 23:37 - Anonymous
- File 24.gif added

#4 - 2022-07-06 23:52 - Holger Just
- File deleted (24.9gif)

#5 - 2022-07-08 20:50 - Anonymous
- File 1161.gif added

#6 - 2022-07-09 01:56 - Go MAEDA
- File deleted (1161.gif)

#7 - 2022-07-15 22:56 - Anonymous
- File 1015.gif added

#8 - 2022-07-16 02:16 - Go MAEDA
- File deleted (1015.gif)

#9 - 2022-08-2511:48-C S

Does anyone have an idea or even a work-around how | can add the HTML elements? Specifying a class and ID for the respective elements would
be completely sufficient so that you can address them specifically via CSS file

#10 - 2022-08-25 12:03 - Holger Just

Right now, custom CSS rules are not allowed at all in Markdown. This is something that may change in the future though to allow a limited set of CSS
rules. We have built this in Planio already and are currently preparing the patches for Redmine to contribute this.

As for custom class attributes, these are generally forbidden due to security concerns. As Redmine uses classes in its own generated HTML to show
style its interfaces, allowing arbitrary classes could allow attackers to hide or affect critical Ul details outside of the rendered markup which is thus
forbidden.

#11 - 2022-09-26 12:37 - Jens Kramer
- File 0002-adds-info-about-custom-CSS-to-commonmark-markdown-he.patch added

- File 0001-allow-select-custom-CSS-properties.patch added

Here's a patch (extracted from Planio) that allows a limited set of CSS properties in CommonMark output. The second patch adds the corresponding
list of allowed properties to the english documentation file.

#12 - 2022-09-26 12:53 - Marius BALTEANU

- Target version set to 5.0.3

#13 - 2022-09-26 20:16 - Mischa The Evil
- Related to Feature #2416: {background:color} doesn't work in text formatting added

#14 - 2022-09-26 20:16 - Mischa The Evil
- Related to Feature #22425: Allow "style" tag in Redcarpet Markdown formatter added

#15 - 2022-09-27 00:42 - Mischa The Evil

| wonder: given the similarity with the list of properties kept in source:/trunk/lib/redmine/wiki_formatting/textile/redcloth3.ro@21848#L 514 for the
Textile formatter, wouldn't it be better to unify both of these and/or extract the list of properties into its own entirely (as it might be useful for other,
third-party formatters too)? Would such be feasible?

Otherwise the patches look good to me... ;)

#16 - 2022-09-27 03:51 - Jens Kramer

Reusing parts of the commonmark HTML pipeline for the other formatters is definitely something we should do in the future. Makes a lot of sense
especially for the Sanitizer, and if I'm not mistaken we could then throw out such formatter-specific sanitization like the one you pointed out.

#17 - 2022-09-27 19:13 - Marius BALTEANU
- Status changed from New to Resolved

- Assignee set to Marius BALTEANU
https://plan.io/redmine-hosting
https://plan.io/redmine-hosting
https://www.redmine.org/projects/redmine/repository/svn/revisions/21848/entry/trunk/lib/redmine/wiki_formatting/textile/redcloth3.rb#L514

- Resolution set to Fixed

Patches committed, thanks.
| think we can handle the reusable part in another ticket.

#18 - 2022-09-27 22:55 - Marius BALTEANU
Fixes merged to 5.0.3.

#19 - 2022-09-27 22:55 - Marius BALTEANU

- Status changed from Resolved to Closed

#20 - 2023-01-09 09:22 - Go MAEDA

- Related to Defect #38073: CommonMark Markdown formatter does not support min-width, max-width, min-height, and max-height CSS properties
added

#21 - 2023-08-29 03:07 - Go MAEDA
- Is duplicate of Feature #35747: Allow style attribute for HTML elements in CommonMark formatter added

Files
0002-adds-info-about-custom-CSS-to-commonmark-markdown-he.patcH .3 KB 2022-09-26 Jens Kramer
0001-allow-select-custom-CSS-properties.patch 2.94 KB 2022-09-26 Jens Kramer
